#include<bits/stdc++.h>
using namespace std;

int n,x,y;
int maxSt=1,br=0;

pair<long long, long long> a[50010];

int main(){
 cin>>n;

 for(int i=0 ; i<n ; i++){
    cin>>x>>y;
    /*for(int j=x[i] ; j<y[i] ; j++){
        a[j]++;
        if(a[j]>maxSt){
            maxSt=a[j];
            br=0;
        }
        if(a[j]==maxSt){
            br++;
        }
    }*/
    a[i].first=x;
    a[i].second=y;
 }
 sort(a,a+n);

 /*for(int i=0 ; i<n ; i++){
    cout<<a[i].first<<" "<<a[i].second<<"      ";
 }*/

 long long k[50010];

 for(int i=0 ; i<a[n-1].second ; i++){
    k[i]=0;
    for(int j=0 ; j<n ; j++){
        if((i+1>=a[j].first && i+1<=a[j].second) && (i>=a[j].first && i<=a[j].second)){
            k[i]++;
            //cout<<i<<" s "<<j<<" ";
        }
    }
    if(k[i]>maxSt){
        maxSt=k[i];
        br=0;
    }

    if(k[i]==maxSt){
        br++;
    }
 }

 cout<<maxSt<<endl<<br;
 return 0;
}

